;This program calculates sum of 2 numbers (0-9)
;Demonstrates follow skills:
;- print string to screen as prompt message
;- read character from keyboard
;-check valid input
;- convert character input to number/vice versa
;- simple integer addition
;- character output to screen - two characters

.model medium
.stack 200h

MIN	EQU 30h			;smallest ASCII code
MAX EQU 39h			;highest ASCII code to accept

.code
start:
        ;***** print title *****
        ;-setup DS register
        mov ax,@data            ;point DS to data segment
        mov ds,ax

        ;-print prompt message 3
		mov dx,offset prompt3   ;point to prompt message 3
        mov ah,09h              ;function: print string
        int 21h
        ;***** end of print title *****

        ;***** reading inputs to NUM1 and NUM2 *****
        ;-print prompt message 1
read1:  mov dx,offset prompt1   ;point to prompt message 1
        mov ah,09h              ;function: print string
        int 21h

        ;-read and check first number
        mov ah,01h              ;function: read character with echo
        int 21h
		
		cmp al,MIN				;check if input less than MIN
		jl error1				;if yes, give error message
        cmp al,MAX				;else, check if input more than MAX
		jle save1				;if not, save the number

error1:	mov dx,offset errmsg	;else, give error message
		mov ah,09h				;function: print string
		int 21h
		jmp read1				;get input again
		
save1:  sub al,30h              ;adjust ASCII to number
        mov NUM1,al             ;save character read into memory NUM1
		
        ;-print prompt message 2
read2:  mov dx,offset prompt2   ;point to prompt message 2
        mov ah,09h              ;function: print string
        int 21h

        ;-read and check second number
		mov ah,01h              ;function: read character with echo
        int 21h

		cmp al,MIN				;check if input less than MIN
		jl error2				;if yes, give error message
        cmp al,MAX				;else, check if input more than MAX
		jle save2				;if not, save the number

error2:	mov dx,offset errmsg	;else, give error message
		mov ah,09h				;function: print string
		int 21h
		jmp read2				;get input again
		
save2:  sub al,30h              ;adjust ASCII to number
        mov NUM2,al             ;save color number into memory NUM2
        ;***** end of inputs *****
		
        ;***** calculate sum *****
        xor al,al               ;clear AL
        add al,NUM1             ;AL=NUM1
        add al,NUM2             ;AL=NUM1+NUM2
        ;***** end calculation *****
		
        ;***** display result *****
		push ax					;save AL incase changed by int 21h
        mov dx,offset prompt4   ;point to prompt message 4
        mov ah,09h              ;function: print string
        int 21h
		pop ax

		;check if SUM>=10
		cmp al,10				;check if the sum is greater or equal 10, i.e. 2 digits
		jl print2				;if less than, print 1 digit (last digit)
		sub al,10				;else take mod 10 to get last digit and print 1 as 1st digit ...

		push ax					;save AL incase changed by int 21h
        mov ah,02h              ;function: display out
        mov dl,31h              ;print 1 as 1st digit ...
        int 21h
		pop ax
		
print2: add al,30h              ;adjust number to ASCII

        mov ah,02h              ;function: display out
        mov dl,al               ;result to display (last digit)
        int 21h
        mov dl,0dh              ;carriage return
        int 21h
        mov dl,0ah              ;new line
        int 21h
        ;***** end display result *****

        mov ax,4c00h            ;function: exit to DOS
        int 21h

.data
NUM1 db 0
NUM2 db 0
prompt1 db 0dh,0ah,"Enter first number (0-9): $"
prompt2 db 0dh,0ah,"Enter second number (0-9): $"
prompt3 db "Simple Calculator Program",0dh,0ah,'$'
prompt4 db 0dh,0ah,"Sum: $"
errmsg	db "  <- Input out of range!$"

end

